/*
  Name: highscore.cpp
  Copyright: Polecatsoft 2005
  Author: Deathlord
  Date: 19.06.05 16:49
  Description: Handles highscore loading / saving
*/

#include "StdAfx.h"
#include "highscore.h"

#include <fstream>

struct highscore
{
	int spring;
	int summer;
	int fall;
	int winter;
};

const std::string hsFilename = "highscore.whs";

void write_hs(struct highscore *hs)
{
	std::ofstream file(hsFilename.c_str(), std::ios::binary);
	if(!file)
	{
		file.close();
		error::fatal("Unable to write to highscore file");
	}
	file.write(reinterpret_cast<char*>(hs), sizeof(hs));
	
	file.close();
}

void load_hs(struct highscore *hs)
{
	std::ifstream file(hsFilename.c_str(), std::ios::binary);
	if(!file)
	{
		file.close();
		error::fatal("Unable to write to highscore file");
	}
	file.read(reinterpret_cast<char*>(hs), sizeof(hs));

	file.close();
}

void highscore(int score, CT type)
{
	struct highscore hsNew;
	struct highscore hsOld;
	hsOld.spring = 0;
	hsOld.summer = 0;
	hsOld.fall = 0;
	hsOld.winter = 0;
	hsNew.spring = 0;
	hsNew.summer = 0;
	hsNew.fall = 0;
	hsNew.winter = 0;
	
	if(fileExists(hsFilename) == false)
	{
		write_hs(&hsOld);
	}
	else
	{
		load_hs(&hsOld);
	}
	
	std::string preHeader = "Highscore for Weazard of ";
	std::string header;
	std::string footer = "-Press Enter to return to main menu-";
	std::string oldScore;
	std::string newScore;
	switch(type)
	{
		case CT_SPRING:
			{
				header = preHeader + "Spring:";
				hsNew.spring = score;
				oldScore = std::string("Old highscore: ") + i2str(hsOld.spring) + std::string(" wins");
				newScore = std::string("Your score: ") + i2str(hsNew.spring) + std::string(" wins");
				break;
			}
		case CT_SUMMER:
			{
				header = preHeader + "Summer:";
				hsNew.summer = score;
				oldScore = std::string("Old highscore: ") + i2str(hsOld.summer) + std::string(" wins");
				newScore = std::string("Your score: ") + i2str(hsNew.summer) + std::string(" wins");
				break;
			}
		case CT_FALL:
			{
				header = preHeader + "Fall:";
				hsNew.fall = score;
				oldScore = std::string("Old highscore: ") + i2str(hsOld.fall) + std::string(" wins");
				newScore = std::string("Your score: ") + i2str(hsNew.fall) + std::string(" wins");
				break;
			}
		case CT_WINTER:
			{
				header = preHeader + "Winter:";
				hsNew.winter = score;
				oldScore = std::string("Old highscore: ") + i2str(hsOld.winter) + std::string(" wins");
				newScore = std::string("Your score: ") + i2str(hsNew.winter) + std::string(" wins");
				break;
			}
	}
	
	write_hs(&hsNew);
	keyStates.anyKey();

	while(!keyStates[KEY_ENTER])
	{
		clear_to_color(global::dbuffer, makecol(0xFD, 0xFA, 0x00));
		textout_centre_ex(global::dbuffer, font, header.c_str(), 320, 100, 0, -1);
		textout_centre_ex(global::dbuffer, font, footer.c_str(), 320, 380, 0, -1);
		textout_ex(global::dbuffer, font, newScore.c_str(), 100, 200, 0, -1);
		textout_ex(global::dbuffer, font, oldScore.c_str(), 100, 300, 0, -1);
		show();
	}
}
