//				Mercenary Soldier
//Message class - this class manages and stores messages revieved from
//scripts, other players and the game itself.

#include <allegro.h>
#include <string>
using namespace std;

#include "StdAfx.h"
#include "messageClass.h"

message::message()
{
	color = 0;
}

void message::draw(int posX, int posY, BITMAP *dest)
{
	if(!empty())
	{
		textout_ex(dest, font, c_str(), posX, posY, color, -1);
	}
}

void message::setColor(int newColor)
{
	color = newColor;
}

void message::erase()
{
	string::erase();
}

void messageClass::sendText(string text)
{
	if(recBuffer[recBuffer.length() - 1] != ' ')
		recBuffer.append(1, ' ');
	recBuffer.append(text);
}

void messageClass::sendInt(int value)
{
	if(recBuffer[recBuffer.length() - 1] != ' ')
		recBuffer.append(1, ' ');
	recBuffer.append(i2str(value));
}

void messageClass::output()
{
	if(used < size)
		++used;
	for(int i = size - 2; i > 0; --i)
	{
		displayedMessages[i] = displayedMessages[i - 1];
	}
	displayedMessages[0].erase();
	displayedMessages[0] = recBuffer;
	recBuffer.erase();
}

messageClass::messageClass(int size, int maxVis, int stdX, BITMAP *drawTo)
{
	if(size)
		displayedMessages = new message[size];
	else
		displayedMessages = 0;

	this->size = size;
	used = 0;

	maxVisible = maxVis;

	dest = drawTo;

	posX = stdX;

	plus = text_height(font) + 2;
}

messageClass::~messageClass()
{
	if(displayedMessages)
		delete [] displayedMessages;
}

void messageClass::draw(int initPosY)
{
	if(!used)
		return;

	bool quit = true;
	int max = maxVisible;
	if(used < maxVisible)
		max = used;

	int i;

	int posY = initPosY;
	int maxX = 0;
	for(i = 0; i < max; ++i)
	{
		int temp;
		temp = text_length(font, displayedMessages[i].c_str()) + posX;
		if(temp > maxX)
			maxX = temp;
	}
	maxX += 2;
	//rectfill(dest, posX - 1, initPosY - 2, maxX, initPosY + plus * max, makecol(0xFF, 0xFF, 0xFF));
	for(i = 0; i < max; ++i)
	{
		displayedMessages[i].draw(posX, posY, dest);
		posY += plus;
	}
}

void messageClass::send(std::string text, int color)
{
	sendText(text);
	output();
	displayedMessages[0].setColor(color);
}
