//				Mercenary Soldier
//Message class - this class manages and stores messages revieved from
//scripts, other players and the game itself.

#ifndef MESSAGE_CLASS_MS
#define MESSAGE_CLASS_MS

#include <allegro.h>
#include <string>

class message : public std::string
{
private:
	int color;
public:
	message();
	void draw(int posX, int posY, BITMAP *dest);
	void erase();
	void setColor(int color);
};

class messageClass
{
private:
	//The message buffer for newly received messages
	message recBuffer;

	//The messages that will be actually displayed
	message *displayedMessages;
	//The bitmap everything will be drawn onto
	BITMAP *dest;
	int size;
	int used;
	int plus;
	int posX;
	int maxVisible;
public:
	messageClass(int size, int maxVis, int stdX, BITMAP *drawTo);
	~messageClass();
	void send(std::string text, int color);
	void sendText(std::string text);
	void sendInt(int value);
	void output();
	void draw(int initPosY);
};

#endif
